#!/bin/env python
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2008-2011 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from ..column import ColumnAttr
from .. import configuration
import time

class ColumnVisibilityDate(ColumnAttr):
    name = 'visibility_date'
    def check(self, date):
        if date == '':
            return
        mktime = time.mktime(time.strptime(date, '%Y%m%d'))
        if mktime > time.time() + 86400*configuration.max_visibility_date:
            return '''_("ALERT_date_in_future_1")+"%d"+
_("ALERT_date_in_future_2")
''' % int((time.mktime(time.strptime(date, '%Y%m%d')) - time.time())/86400)
        if mktime < time.time() - 86400:
            return '_("ALERT_date_in_past")'
    formatter = '''
function(column, value)
{
  if ( value === '' ) return '' ;
  return column.visibility_date.substr(6,2) + '/' +
	 column.visibility_date.substr(4,2) + '/' +
	 column.visibility_date.substr(0,4) ;
}'''
    check_and_set = 'set_visibility_date'
    css = """
#t_column_visibility_date.empty {
  background-image: url('visible.png');
  background-repeat: no-repeat;
  background-position: 2px 2px;
}

#menutop DIV.tabs #t_column_visibility_date { width: 73% }

"""
